REM Paste an Object to all Movie Frames
REM Updated on Aug 23, 1996 by Rob Wineck
REM ********************************************************

REM Array of Names - Room for 10, increase if you need more
DIM ObjNames(10) as STRING
NameVal% = 1
StartOpacity% = 100
EndOPacity% = 100

REM Set to FALSE if you don't want the dialog box
bWarning% = TRUE

BEGIN DIALOG PasteObject 193, 123, "Paste Object To Frames"
	TEXT  14, 20, 38, 8, "Start Frame"
	TEXT  14, 37, 36, 8, "End Frame"
	SPINCONTROL  58, 18, 30, 13, nStart%
	SPINCONTROL  58, 36, 30, 14, nEnd%
	OKBUTTON  106, 106, 40, 14
	CANCELBUTTON  149, 106, 40, 14
	LISTBOX  105, 14, 84, 90, ObjNames, NameVal%
	GROUPBOX  5, 4, 95, 55, "Frame Range"
	SPINCONTROL  58, 78, 30, 14, StartOpacity%
	SPINCONTROL  58, 98, 30, 14, EndOpacity%
	TEXT  12, 82, 41, 8, "Start Opacity"
	TEXT  12, 100, 39, 8, "End Opacity"
	TEXT  106, 4, 50, 8, "Select Object"
	GROUPBOX  5, 65, 96, 55, "Object Settings"
END DIALOG

label1 = "This script combines all objects with the background."  \\
					+ CHR(13)+CHR(10)+ CHR(13)+CHR(10)+ \\
					"NOTE: A 24-bit or grayscale movie must be open in Corel PHOTO-PAINT. Ensure all objects are properly positioned before running the script."

BEGIN DIALOG Dialog1 196, 80, "Movie Paste"
	GROUPBOX  2, 1, 191, 59
	TEXT  8, 9, 178, 47, label1
	OKBUTTON  109, 64, 40, 14
	CANCELBUTTON  153, 64, 40, 14
END DIALOG

ret = DIALOG(Dialog1)
' If Cancel is selected, stop the script
IF ret = 2 THEN STOP

WITHOBJECT "CorelPhotoPaint.Automation.8"
	REM Get the Number of Frames in the Movie	
	nFrames% = .GetFrameCount()
	nStart% = 1
	nEnd% = nFrames

	if (nFrames = 0) THEN
		BEEP
		message "This script runs on Movie Files"
		STOP
	ENDIF
	
	nObjects% = .GetObjectCount()
	if (nObjects = 0) then
		BEEP
		message "This script needs objects"
		STOP
	endif

	'Make the Pick Tool Active
	.SetActiveTool 34501
	
	FOR i% = 1 TO nObjects 
		ObjNames(i%) = .GetObjectName(i%)
	NEXT i%

	REM Do the Dialog. No error checking so enter proper values
	ret2 = DIALOG(PasteObject)
	IF ret2 = 2 THEN STOP

	REM Select the Chosen Object, and make a shadow for it
	.ObjectSelectNone
	.ObjectSelect NameVal, -1
	.GetObjectRectangle NameVal, oLeft&, oTop&, oRight&, oBottom&
	.EditCut
	
	REM Calculate Fade Factor
	increment& = (EndOpacity - StartOpacity) / ((nEnd - nStart) + 1)
	
	For i% = nStart to nEnd	
		.MovieGotoFrame i
		.EditPasteObject oLeft, oBottom, "" 
		.ObjectSelectNone 
		.ObjectSelect nObjects, -1
		.ObjectOpacity StartOpacity + (i - nStart) * increment
		.ObjectMerge 0
	Next i
END WITHOBJECT
